Index: /trunk/LMDZ.GENERIC/libf/phystd/tabfi.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/tabfi.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/tabfi.F	(revision 253)
@@ -102,13 +102,13 @@
 c----------------------------------------------
       year_day = 669.           ! length of year (sols) ~668.6
-      periheli = 206.66         ! min. Star-Planet distance (Mkm) ~206.66
-      aphelie = 249.22          ! max. Star-Planet distance (Mkm) ~249.22
-      peri_day =  485.          ! date of perihelion (sols since N. spring)
+      periastr = 206.66         ! min. Star-Planet distance (Mkm) ~206.66
+      apoastr = 249.22          ! max. Star-Planet distance (Mkm) ~249.22
+      peri_day =  485.          ! date of periastron (sols since N. spring)
       obliquit = 25.19          ! Obliquity of the planet (deg) ~25.19
 
 c additional for stokes.F added by RDW
 c-------------------------------------
-      molrad=2.2e-10   ! CO2
-      visc=1.e-5       ! CO2
+!      molrad=2.2e-10   ! CO2
+!      visc=1.e-5       ! CO2
 
 c Boundary layer and turbulence
@@ -180,6 +180,6 @@
 c Informations about planet for the physics only
       year_day = tab_cntrl(tab0+14)
-      periheli = tab_cntrl(tab0+15)
-      aphelie = tab_cntrl(tab0+16)
+      periastr = tab_cntrl(tab0+15)
+      apoastr = tab_cntrl(tab0+16)
       peri_day = tab_cntrl(tab0+17)
       obliquit = tab_cntrl(tab0+18)
@@ -239,6 +239,6 @@
 
       write(*,5) '(14)       year_day',tab_cntrl(tab0+14),year_day
-      write(*,5) '(15)       periheli',tab_cntrl(tab0+15),periheli
-      write(*,5) '(16)        aphelie',tab_cntrl(tab0+16),aphelie
+      write(*,5) '(15)       periastr',tab_cntrl(tab0+15),periastr
+      write(*,5) '(16)        apoastr',tab_cntrl(tab0+16),apoastr
       write(*,5) '(17)       peri_day',tab_cntrl(tab0+17),peri_day
       write(*,5) '(18)       obliquit',tab_cntrl(tab0+18),obliquit
@@ -288,10 +288,10 @@
       write(*,*) '(27)        tauvis : mean dust vis. reference ',
      &           'opacity'
-      write(*,*) '(35)         volcapa : soil volumetric heat capacity'
-      write(*,*) '(18)        obliquit : planet obliquity (deg)'
-      write(*,*) '(17)      peri_day : perihelion date (sol since Ls=0)'
-      write(*,*) '(15)      periheli : min. sun-mars dist (Mkm)'
-      write(*,*) '(16)      aphelie  : max. sun-mars dist (Mkm)'
-      write(*,*) '(14)      year_day : length of year (in sols)'
+      write(*,*) '(35)      volcapa : soil volumetric heat capacity'
+      write(*,*) '(18)     obliquit : planet obliquity (deg)'
+      write(*,*) '(17)     peri_day : periastron date (sols since Ls=0)'
+      write(*,*) '(15)     periastr : min. star-planet dist (Mkm)'
+      write(*,*) '(16)     apoastr  : max. star-planet (Mkm)'
+      write(*,*) '(14)     year_day : length of year (in sols)'
       write(*,*) '(5) rad : radius of the planet (m)'
       write(*,*) '(6) omeg : planet rotation rate (rad/s)'
@@ -445,21 +445,21 @@
           write(*,*) ' peri_day (new value):',peri_day
 
-        else if (modif(1:len_trim(modif)) .eq. 'periheli') then
-          write(*,*) 'current value:',periheli
-          write(*,*) 'perihelion should be 206.66 on current Mars'
-          write(*,*) 'enter new value:'
- 117      read(*,*,iostat=ierr) periheli
+        else if (modif(1:len_trim(modif)) .eq. 'periastr') then
+          write(*,*) 'current value:',periastr
+          write(*,*) 'periastr should be 206.66 on present-day Mars'
+          write(*,*) 'enter new value:'
+ 117      read(*,*,iostat=ierr) periastr
           if(ierr.ne.0) goto 117
           write(*,*) 
-          write(*,*) ' periheli (new value):',periheli
- 
-        else if (modif(1:len_trim(modif)) .eq. 'aphelie') then
-          write(*,*) 'current value:',aphelie
-          write(*,*) 'aphelion should be 249.22 on current Mars'
-          write(*,*) 'enter new value:'
- 118      read(*,*,iostat=ierr) aphelie
+          write(*,*) ' periastr (new value):',periastr
+ 
+        else if (modif(1:len_trim(modif)) .eq. 'apoastr') then
+          write(*,*) 'current value:',apoastr
+          write(*,*) 'apoastr should be 249.22 on present-day Mars'
+          write(*,*) 'enter new value:'
+ 118      read(*,*,iostat=ierr) apoastr
           if(ierr.ne.0) goto 118
           write(*,*) 
-          write(*,*) ' aphelie (new value):',aphelie
+          write(*,*) ' apoastr (new value):',apoastr
  
         else if (modif(1:len_trim(modif)) .eq. 'volcapa') then
@@ -556,6 +556,6 @@
  
       write(*,5) '(14)       year_day',tab_cntrl(tab0+14),year_day
-      write(*,5) '(15)       periheli',tab_cntrl(tab0+15),periheli
-      write(*,5) '(16)        aphelie',tab_cntrl(tab0+16),aphelie
+      write(*,5) '(15)       periastr',tab_cntrl(tab0+15),periastr
+      write(*,5) '(16)        apoastr',tab_cntrl(tab0+16),apoastr
       write(*,5) '(17)       peri_day',tab_cntrl(tab0+17),peri_day
       write(*,5) '(18)       obliquit',tab_cntrl(tab0+18),obliquit
Index: /trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/totalcloudfrac.F90	(revision 253)
@@ -0,0 +1,70 @@
+      subroutine totalcloudfrac(rneb,totalrneb)
+
+      implicit none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates the total cloud fraction 
+!     
+!     Authors
+!     -------
+!     Adapted from the LMDTERRE code by B Charnay (2010)
+!     
+!==================================================================
+
+#include "dimensions.h"
+#include "dimphys.h"
+#include "comcstfi.h"
+#include "tracer.h"
+#include "fisice.h"
+#include "comgeomfi.h"
+#include "comdiurn.h"
+
+      real rneb(ngridmx,nlayermx)             ! cloud fraction     
+      real totalrneb(ngridmx)                 ! total cloud fraction 
+
+      integer recovery
+      parameter(recovery=1)
+
+! hypothesis behind recovery. value: 
+! 1 = random recovery
+! 2 = maximal recovery
+! 3 = minimal recovery
+
+
+!     Local variables
+      integer ig, l
+      real clear
+
+      do ig=1,ngridmx
+         totalrneb(ig) = 0.
+
+         if (recovery.eq.1) then
+            clear = (1.-rneb(ig,1))
+            do l=2,nlayermx       
+               clear = clear*(1.-rneb(ig,l))
+            enddo
+            totalrneb(ig) = 1.-clear
+
+         elseif (recovery.eq.2) then
+            totalrneb(ig) = rneb(ig,1)
+            do l=2,nlayermx       
+               totalrneb(ig) = max(rneb(ig,l),totalrneb(ig))
+            enddo
+            
+         elseif (recovery.eq.3) then
+            totalrneb(ig) = rneb(ig,1)
+            do l=2,nlayermx       
+               totalrneb(ig) = min(rneb(ig,l),totalrneb(ig))
+            enddo
+         endif                  ! (recovery=)
+         
+         totalrneb(ig) = min(1.,totalrneb(ig))
+         totalrneb(ig) = max(0.,totalrneb(ig))
+         
+      enddo                     ! (ig=)
+      
+      
+    end subroutine totalcloudfrac
Index: /trunk/LMDZ.GENERIC/libf/phystd/vdifc.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/vdifc.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/vdifc.F	(revision 253)
@@ -1,33 +1,36 @@
-      SUBROUTINE vdifc(ngrid,nlay,nq,ppopsk,
-     $                ptimestep,pcapcal,lecrit,
-     $                pplay,pplev,pzlay,pzlev,pz0,
-     $                pu,pv,ph,pq,ptsrf,pemis,pqsurf,
-     $                pdufi,pdvfi,pdhfi,pdqfi,pfluxsrf,
-     $                pdudif,pdvdif,pdhdif,pdtsrf,pq2,
-     $                pdqdif,pdqsdif)
-
-      use watercommon_h, only : RLVTT
+      subroutine vdifc(ngrid,nlay,nq,rnat,ppopsk,         
+     &     ptimestep,pcapcal,lecrit,                        
+     &     pplay,pplev,pzlay,pzlev,pz0,
+     &     pu,pv,ph,pq,ptsrf,pemis,pqsurf,
+     &     pdufi,pdvfi,pdhfi,pdqfi,pfluxsrf,
+     &     pdudif,pdvdif,pdhdif,pdtsrf,pq2,
+     &     pdqdif,pdqsdif)
+
+      use watercommon_h, only : RLVTT, To, RCPD, mx_eau_sol
 
       implicit none
 
-c=======================================================================
-c
-c   subject:
-c   --------
-c   Turbulent diffusion (mixing) for potential T, U, V and tracer
-c
-c   Shema implicite
-c   On commence par rajouter au variables x la tendance physique
-c   et on resoult en fait:
-c      x(t+1) =  x(t) + dt * (dx/dt)phys(t)  +  dt * (dx/dt)difv(t+1)
-c
-c   author:
-c   ------
-c      Hourdin/Forget/Fournier
-c=======================================================================
-
-c-----------------------------------------------------------------------
-c   declarations:
-c   -------------
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Turbulent diffusion (mixing) for pot. T, U, V and tracers
+!     
+!     Implicit scheme
+!     We start by adding to variables x the physical tendencies
+!     already computed. We resolve the equation:
+!
+!     x(t+1) =  x(t) + dt * (dx/dt)phys(t)  +  dt * (dx/dt)difv(t+1)
+!     
+!     Authors
+!     ------- 
+!     F. Hourdin, F. Forget, R. Fournier (199X)
+!     R. Wordsworth, B. Charnay (2010)
+!     
+!==================================================================
+
+!-----------------------------------------------------------------------
+!     declarations
+!     ------------
 
 #include "dimensions.h"
@@ -40,8 +43,7 @@
 
 #include "watercap.h"
-c
-c   arguments:
-c   ----------
-
+
+!     arguments
+!     ---------
       INTEGER ngrid,nlay
       REAL ptimestep
@@ -55,22 +57,23 @@
       REAL pdtsrf(ngrid),pcapcal(ngrid)
       REAL pq2(ngrid,nlay+1)
-
-c    Argument added for condensation:
-!      REAL co2ice (ngrid)
+      
+      integer rnat(ngrid)      
+
+!     Arguments added for condensation
       REAL ppopsk(ngrid,nlay)
       logical lecrit
       REAL pz0
 
-c    Traceurs :
+!     Tracers
+!     --------
       integer nq 
-      REAL pqsurf(ngrid,nq)
+      real pqsurf(ngrid,nq)
       real pq(ngrid,nlay,nq), pdqfi(ngrid,nlay,nq) 
       real pdqdif(ngrid,nlay,nq) 
       real pdqsdif(ngrid,nq) 
       
-c   local:
-c   ------
-
-      INTEGER ilev,ig,ilay,nlev
+!     local
+!     -----
+      integer ilev,ig,ilay,nlev
 
       REAL z4st,zdplanck(ngridmx)
@@ -86,62 +89,104 @@
       REAL zc(ngridmx,nlayermx),zd(ngridmx,nlayermx)
       REAL zcst1
-      REAL zu2
-
-      EXTERNAL SSUM,SCOPY
-      REAL SSUM
+      REAL zu2!, a
+      REAL zcq(ngridmx,nlayermx),zdq(ngridmx,nlayermx)
+      REAL evap(ngridmx)
+      REAL zcq0(ngridmx),zdq0(ngridmx)
+      REAL zx_alf1(ngridmx),zx_alf2(ngridmx)
+
       LOGICAL firstcall
       SAVE firstcall
 
-c     variable added for CO2 condensation:
-c     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
-      REAL hh , zhcond(ngridmx,nlayermx)
-      REAL latcond,tcond1mb
-      REAL acond,bcond
-      SAVE acond,bcond
-      DATA latcond,tcond1mb/5.9e5,136.27/
-
-c    Tracers :
-c    ~~~~~~~ 
+!     variables added for CO2 condensation
+!     ------------------------------------
+      REAL hh                   !, zhcond(ngridmx,nlayermx)
+!     REAL latcond,tcond1mb
+!     REAL acond,bcond
+!     SAVE acond,bcond
+!     DATA latcond,tcond1mb/5.9e5,136.27/
+
+!     Tracers
+!     -------
       INTEGER iq
       REAL zq(ngridmx,nlayermx,nqmx)
       REAL zq1temp(ngridmx)
-      REAL rho(ngridmx) ! near surface air density
+      REAL rho(ngridmx)         ! near-surface air density
       REAL qsat(ngridmx)
       DATA firstcall/.true./
       REAL kmixmin
 
-c    ** un petit test de coherence
-c       --------------------------
+!     Variables added for implicit latent heat inclusion
+!     --------------------------------------------------
+      real latconst, dqsat(ngridmx), qsat_temp1, qsat_temp2
+      real z1_Tdry(ngridmx), z2_Tdry(ngridmx)
+      real z1_T(ngridmx), z2_T(ngridmx)
+      real zb_T(ngridmx)
+      real zc_T(ngridmx,nlayermx)
+      real zd_T(ngridmx,nlayermx)
+      real lat1(ngridmx), lat2(ngridmx)
+      real surfh2otot
+      logical surffluxdiag
+      integer isub ! sub-loop for precision
+
+      integer ivap, iice ! also make liq for clarity on surface...
+      save ivap, iice
+
+      real, parameter :: sigma=5.67e-8
+      real, parameter :: karman=0.4
+      real cd0, roughratio
+
+      logical forceWC
+      real masse, Wtot, Wdiff
+
+      real dqsdif_total(ngrid) 
+      real zq0(ngrid) 
+
+      forceWC=.true.
+!      forceWC=.false.
+
+
+!     Coherence test
+!     --------------
 
       IF (firstcall) THEN
-         IF(ngrid.NE.ngridmx) THEN
-            PRINT*,'STOP dans vdifc'
-            PRINT*,'probleme de dimensions :'
-            PRINT*,'ngrid  =',ngrid
-            PRINT*,'ngridmx  =',ngridmx
-            STOP
-         ENDIF
-c        To compute: Tcond= 1./(bcond-acond*log(.0095*p)) (p in pascal)
-         bcond=1./tcond1mb
-         acond=r/latcond
-         PRINT*,'In vdifc: Tcond(P=1mb)=',tcond1mb,' Lcond=',latcond
-         PRINT*,'          acond,bcond',acond,bcond
-
-        firstcall=.false.
+!         IF(ngrid.NE.ngridmx) THEN
+!            PRINT*,'STOP dans vdifc'
+!            PRINT*,'probleme de dimensions :'
+!            PRINT*,'ngrid  =',ngrid
+!            PRINT*,'ngridmx  =',ngridmx
+!            STOP
+!         ENDIF
+!     To compute: Tcond= 1./(bcond-acond*log(.0095*p)) (p in pascal)
+!     bcond=1./tcond1mb
+!     acond=r/latcond
+!     PRINT*,'In vdifc: Tcond(P=1mb)=',tcond1mb,' Lcond=',latcond
+!     PRINT*,'          acond,bcond',acond,bcond
+
+         if(water)then
+!                iliq=igcm_h2o_vap
+                ivap=igcm_h2o_vap
+                iice=igcm_h2o_ice ! simply to make the code legible               
+                                  ! to be generalised later
+         endif
+
+         if(ngridmx.ne.1)then
+            if(nonideal)then
+               print*,'Nonideal doesnt work yet in 3D!!!'
+               call abort
+            endif
+         endif
+
+         firstcall=.false.
       ENDIF
 
-
-
-
-
-c-----------------------------------------------------------------------
-c    1. initialisation
-c    -----------------
+!-----------------------------------------------------------------------
+!     1. Initialisation
+!     -----------------
 
       nlev=nlay+1
 
-c    ** calcul de rho*dz et dt*rho/dz=dt*rho**2 g/dp
-c       avec rho=p/RT=p/ (R Theta) (p/ps)**kappa
-c       ----------------------------------------
+!     Calculate rho*dz and dt*rho/dz=dt*rho**2 g/dp
+!     with rho=p/RT=p/ (R Theta) (p/ps)**kappa
+!     ---------------------------------------------
 
       DO ilay=1,nlay
@@ -151,55 +196,23 @@
       ENDDO
 
-      zcst1=4.*g*ptimestep/(r*r)
+      zcst1=4.*g*ptimestep/(R*R)
       DO ilev=2,nlev-1
          DO ig=1,ngrid
             zb0(ig,ilev)=pplev(ig,ilev)*
-     s      (pplev(ig,1)/pplev(ig,ilev))**rcp /
-     s      (ph(ig,ilev-1)+ph(ig,ilev))
+     s           (pplev(ig,1)/pplev(ig,ilev))**rcp /
+     s           (ph(ig,ilev-1)+ph(ig,ilev))
             zb0(ig,ilev)=zcst1*zb0(ig,ilev)*zb0(ig,ilev)/
-     s      (pplay(ig,ilev-1)-pplay(ig,ilev))
-         ENDDO
-      ENDDO
-      DO ig=1,ngrid
-		 zb0(ig,1)=ptimestep*pplev(ig,1)/(r*ptsrf(ig))
-      ENDDO
-
-c    ** diagnostique pour l'initialisation
-c       ----------------------------------
-
-      IF(lecrit) THEN
-         ig=ngrid/2+1
-         PRINT*,'Pression (mbar) ,altitude (km),u,v,theta, rho dz'
-         DO ilay=1,nlay
-            WRITE(*,'(6f11.5)')
-     s      .01*pplay(ig,ilay),.001*pzlay(ig,ilay),
-     s      pu(ig,ilay),pv(ig,ilay),ph(ig,ilay),za(ig,ilay)
-         ENDDO
-         PRINT*,'Pression (mbar) ,altitude (km),zb'
-         DO ilev=1,nlay
-            WRITE(*,'(3f15.7)')
-     s      .01*pplev(ig,ilev),.001*pzlev(ig,ilev),
-     s      zb0(ig,ilev)
-         ENDDO
-      ENDIF
-
-c     Potential Condensation temperature:
-c     -----------------------------------
-
-c     if (callcond) then 
-c       DO ilev=1,nlay
-c         DO ig=1,ngrid
-c           zhcond(ig,ilev) =
-c    &  (1./(bcond-acond*log(.0095*pplay(ig,ilev))))/ppopsk(ig,ilev)
-c         END DO
-c       END DO
-c     else
-        call zerophys(ngrid*nlay,zhcond)
-c     end if
-
-
-c-----------------------------------------------------------------------
-c   2. ajout des tendances physiques
-c      -----------------------------
+     s           (pplay(ig,ilev-1)-pplay(ig,ilev))
+         ENDDO
+      ENDDO
+      DO ig=1,ngrid
+         zb0(ig,1)=ptimestep*pplev(ig,1)/(R*ptsrf(ig))
+      ENDDO
+
+      dqsdif_total(:)=0.0
+
+!-----------------------------------------------------------------------
+!     2. Add the physical tendencies computed so far
+!     ----------------------------------------------
 
       DO ilev=1,nlay
@@ -208,85 +221,71 @@
             zv(ig,ilev)=pv(ig,ilev)+pdvfi(ig,ilev)*ptimestep
             zh(ig,ilev)=ph(ig,ilev)+pdhfi(ig,ilev)*ptimestep
-            zh(ig,ilev)=max(zh(ig,ilev),zhcond(ig,ilev))
          ENDDO
       ENDDO
       if(tracer) then
-        DO iq =1, nq
-         DO ilev=1,nlay
-           DO ig=1,ngrid
-              zq(ig,ilev,iq)=pq(ig,ilev,iq)+pdqfi(ig,ilev,iq)*ptimestep
-           ENDDO
-         ENDDO
-        ENDDO
+         DO iq =1, nq
+            DO ilev=1,nlay
+               DO ig=1,ngrid
+                  zq(ig,ilev,iq)=pq(ig,ilev,iq) + 
+     &                 pdqfi(ig,ilev,iq)*ptimestep
+               ENDDO
+            ENDDO
+         ENDDO
       end if
 
-c-----------------------------------------------------------------------
-c   3. schema de turbulence
-c      --------------------
-
-c    ** source d'energie cinetique turbulente a la surface
-c       (condition aux limites du schema de diffusion turbulente
-c       dans la couche limite
-c       ---------------------
-
-      CALL vdif_cd( ngrid,nlay,pz0,g,pzlay,pu,pv,ptsrf,ph
-     &             ,zcdv_true,zcdh_true)
-      DO ig=1,ngrid
-        zu2=pu(ig,1)*pu(ig,1)+pv(ig,1)*pv(ig,1)
-        zcdv(ig)=zcdv_true(ig)*sqrt(zu2)
-        zcdh(ig)=zcdh_true(ig)*sqrt(zu2)
-      ENDDO
-
-c    ** schema de diffusion turbulente dans la couche limite
-c       ---------------------------------------------------- 
-
-        CALL vdif_kc(ptimestep,g,pzlev,pzlay
-     &              ,pu,pv,ph,zcdv_true
-     &              ,pq2,zkv,zkh)
-
-
-c    Adding eddy mixing to mimic 3D general circulation in 1D
-c    RW FF 2010
+!-----------------------------------------------------------------------
+!     3. Turbulence scheme
+!     --------------------
+!
+!     Source of turbulent kinetic energy at the surface
+!     ------------------------------------------------- 
+!     Formula is Cd_0 = (karman / log[1+z1/z0])^2
+
+      DO ig=1,ngrid
+         roughratio = 1.E+0 + pzlay(ig,1)/pz0
+         cd0 = karman/log(roughratio)
+         cd0 = cd0*cd0
+         zcdv_true(ig) = cd0
+         zcdh_true(ig) = cd0
+      ENDDO
+
+      DO ig=1,ngrid
+         zu2=pu(ig,1)*pu(ig,1)+pv(ig,1)*pv(ig,1)
+         zcdv(ig)=zcdv_true(ig)*sqrt(zu2)
+         zcdh(ig)=zcdh_true(ig)*sqrt(zu2)
+      ENDDO
+
+!     Turbulent diffusion coefficients in the boundary layer
+!     ------------------------------------------------------ 
+
+      call vdif_kc(ptimestep,g,pzlev,pzlay
+     &     ,pu,pv,ph,zcdv_true
+     &     ,pq2,zkv,zkh)
+
+!     Adding eddy mixing to mimic 3D general circulation in 1D
+!     R. Wordsworth & F. Forget (2010)
       if ((ngrid.eq.1)) then
-        kmixmin = 1.0e-2   ! minimum eddy mix coeff in 1D
-        do ilev=1,nlay
-          do ig=1,ngrid
-           zkh(ig,ilev) = max(kmixmin,zkh(ig,ilev))
-           zkv(ig,ilev) = max(kmixmin,zkv(ig,ilev))
-           !zkh(ig,ilev) = kmixmin
-           !zkv(ig,ilev) = kmixmin
-          end do
-        end do
+         kmixmin = 1.0e-2       ! minimum eddy mix coeff in 1D
+         do ilev=1,nlay
+            do ig=1,ngrid
+               !zkh(ig,ilev) = 1.0
+               zkh(ig,ilev) = max(kmixmin,zkh(ig,ilev))
+               zkv(ig,ilev) = max(kmixmin,zkv(ig,ilev))
+            end do
+         end do
       end if
 
-
-c    ** diagnostique pour le schema de turbulence
-c       -----------------------------------------
-
-      IF(lecrit) THEN
-         PRINT*
-         PRINT*,'Diagnostic for the vertical turbulent mixing'
-         PRINT*,'Cd for momentum and potential temperature'
-
-         PRINT*,zcdv(ngrid/2+1),zcdh(ngrid/2+1)
-         PRINT*,'Mixing coefficient for momentum and pot.temp.'
-         DO ilev=1,nlay
-            PRINT*,zkv(ngrid/2+1,ilev),zkh(ngrid/2+1,ilev)
-         ENDDO
-      ENDIF
-
-c-----------------------------------------------------------------------
-c   4. inversion pour l'implicite sur u
-c      --------------------------------
-
-c    ** l'equation est 
-c       u(t+1) =  u(t) + dt * {(du/dt)phys}(t)  +  dt * {(du/dt)difv}(t+1)
-c       avec
-c       /zu/ = u(t) + dt * {(du/dt)phys}(t)   (voir paragraphe 2.)
-c       et
-c       dt * {(du/dt)difv}(t+1) = dt * {(d/dz)[ Ku (du/dz) ]}(t+1)
-c       donc les entrees sont /zcdv/ pour la condition a la limite sol
-c       et /zkv/ = Ku
- 
+!-----------------------------------------------------------------------
+!     4. Implicit inversion of u
+!     --------------------------
+
+!     u(t+1) =  u(t) + dt * {(du/dt)phys}(t)  +  dt * {(du/dt)difv}(t+1)
+!     avec
+!     /zu/ = u(t) + dt * {(du/dt)phys}(t)   (voir paragraphe 2.)
+!     et
+!     dt * {(du/dt)difv}(t+1) = dt * {(d/dz)[ Ku (du/dz) ]}(t+1)
+!     donc les entrees sont /zcdv/ pour la condition a la limite sol
+!     et /zkv/ = Ku
+      
       CALL multipl((nlay-1)*ngrid,zkv(1,2),zb0(1,2),zb(1,2))
       CALL multipl(ngrid,zcdv,zb0,zb)
@@ -301,7 +300,7 @@
          DO ig=1,ngrid
             z1(ig)=1./(za(ig,ilay)+zb(ig,ilay)+
-     $         zb(ig,ilay+1)*(1.-zd(ig,ilay+1)))
+     $           zb(ig,ilay+1)*(1.-zd(ig,ilay+1)))
             zc(ig,ilay)=(za(ig,ilay)*zu(ig,ilay)+
-     $         zb(ig,ilay+1)*zc(ig,ilay+1))*z1(ig)
+     $           zb(ig,ilay+1)*zc(ig,ilay+1))*z1(ig)
             zd(ig,ilay)=zb(ig,ilay)*z1(ig)
          ENDDO
@@ -317,16 +316,15 @@
       ENDDO
 
-c-----------------------------------------------------------------------
-c   5. inversion pour l'implicite sur v
-c      --------------------------------
-
-c    ** l'equation est 
-c       v(t+1) =  v(t) + dt * {(dv/dt)phys}(t)  +  dt * {(dv/dt)difv}(t+1)
-c       avec
-c       /zv/ = v(t) + dt * {(dv/dt)phys}(t)   (voir paragraphe 2.)
-c       et
-c       dt * {(dv/dt)difv}(t+1) = dt * {(d/dz)[ Kv (dv/dz) ]}(t+1)
-c       donc les entrees sont /zcdv/ pour la condition a la limite sol
-c       et /zkv/ = Kv
+!-----------------------------------------------------------------------
+!     5. Implicit inversion of v
+!     --------------------------
+
+!     v(t+1) =  v(t) + dt * {(dv/dt)phys}(t)  +  dt * {(dv/dt)difv}(t+1)
+!     avec
+!     /zv/ = v(t) + dt * {(dv/dt)phys}(t)   (voir paragraphe 2.)
+!     et
+!     dt * {(dv/dt)difv}(t+1) = dt * {(d/dz)[ Kv (dv/dz) ]}(t+1)
+!     donc les entrees sont /zcdv/ pour la condition a la limite sol
+!     et /zkv/ = Kv
 
       DO ig=1,ngrid
@@ -339,7 +337,7 @@
          DO ig=1,ngrid
             z1(ig)=1./(za(ig,ilay)+zb(ig,ilay)+
-     $         zb(ig,ilay+1)*(1.-zd(ig,ilay+1)))
+     $           zb(ig,ilay+1)*(1.-zd(ig,ilay+1)))
             zc(ig,ilay)=(za(ig,ilay)*zv(ig,ilay)+
-     $         zb(ig,ilay+1)*zc(ig,ilay+1))*z1(ig)
+     $           zb(ig,ilay+1)*zc(ig,ilay+1))*z1(ig)
             zd(ig,ilay)=zb(ig,ilay)*z1(ig)
          ENDDO
@@ -355,18 +353,22 @@
       ENDDO
 
-c-----------------------------------------------------------------------
-c   6. inversion pour l'implicite sur h sans oublier le couplage
-c      avec le sol (conduction)
-c      ------------------------
-
-c    ** l'equation est 
-c       h(t+1) =  h(t) + dt * {(dh/dt)phys}(t)  +  dt * {(dh/dt)difv}(t+1)
-c       avec
-c       /zh/ = h(t) + dt * {(dh/dt)phys}(t)   (voir paragraphe 2.)
-c       et
-c       dt * {(dh/dt)difv}(t+1) = dt * {(d/dz)[ Kh (dh/dz) ]}(t+1)
-c       donc les entrees sont /zcdh/ pour la condition de raccord au sol
-c       et /zkh/ = Kh
-c       -------------
+!----------------------------------------------------------------------------
+!     6. Implicit inversion of h, not forgetting the coupling with the ground
+
+!     h(t+1) =  h(t) + dt * {(dh/dt)phys}(t)  +  dt * {(dh/dt)difv}(t+1)
+!     avec
+!     /zh/ = h(t) + dt * {(dh/dt)phys}(t)   (voir paragraphe 2.)
+!     et
+!     dt * {(dh/dt)difv}(t+1) = dt * {(d/dz)[ Kh (dh/dz) ]}(t+1)
+!     donc les entrees sont /zcdh/ pour la condition de raccord au sol
+!     et /zkh/ = Kh
+
+!     Using the wind modified by friction for lifting and sublimation
+!     ---------------------------------------------------------------
+         DO ig=1,ngrid
+            zu2      = zu(ig,1)*zu(ig,1)+zv(ig,1)*zv(ig,1)
+            zcdv(ig) = zcdv_true(ig)*sqrt(zu2)
+            zcdh(ig) = zcdh_true(ig)*sqrt(zu2)
+         ENDDO
 
       CALL multipl((nlay-1)*ngrid,zkh(1,2),zb0(1,2),zb(1,2))
